<?php
	/**
	 * Created by EMRAH M.
	 */
	header("Content-Type: application/json");
	if (isset($_SERVER['HTTP_ORIGIN'])) {
		header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
		header('Access-Control-Allow-Credentials: true');
		header('Access-Control-Max-Age: 86400');
	}if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

	if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS, HEAD");         

	if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
		header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
		exit(0); 
	}
	date_default_timezone_set('Europe/Sarajevo');
	
	$DB_INDEX = array(
		'DB_DATABASE1',
		'DB_DATABASE2'
	);
	
	$REPORT_NAMES = array('HoReCa', 'Sličice');

	$postData = json_decode(file_get_contents('php://input'), true);
	
	if(!isset($postData)) die(json_encode(array('status' => '-1')));

	if(!isset($postData['action'])) die(json_encode(array('status' => '-2')));
	
	if(!isset($postData['db'])) die(json_encode(array('status' => '-2')));
	
	error_log(print_r($postData, true));
	
	require_once 'db.php';
	
	define('VERSION', '1.6.3');
	
	if($postData['action'] == 'getAll'){
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$articles = queryDb($dc, 'select * from articles')){
			die(json_encode(array('status' => '-3')));
		}
		
		if(!$commercialists = queryDb($dc, 'select * from commercialists')){
			die(json_encode(array('status' => '-3')));
		}
		
		if(!$customers = queryDb($dc, 'select id, name from customers')){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode(
			array(
				'customers' => $customers,
				'articles' => $articles,
				'commercialists' => $commercialists
			));
	}
	else if($postData['action'] == 'getCustomers'){
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$customers = queryDb($dc, 'select id, name from customers')){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($customers);
	}
	else if($postData['action'] == 'getCustomer'){
		
		if(!isset($postData['id'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$customer = queryDb($dc, 'select * from customers where id = '.$postData['id'])){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($customer[0]);
	}
	else if($postData['action'] == 'getArticles'){
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$articles = queryDb($dc, 'select * from articles')){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($articles);
	}
	else if($postData['action'] == 'getArticle'){
		
		if(!isset($postData['id'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$article = queryDb($dc, 'select * from articles where id = '.$postData['id'])){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($article[0]);
	}
	else if($postData['action'] == 'getCommercialists'){
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$commercialists = queryDb($dc, 'select id, name from commercialists')){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($commercialists);
	}
	else if($postData['action'] == 'getCommercialist'){
		
		if(!isset($postData['id'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$commercialist= queryDb($dc, 'select * from commercialists where id = '.$postData['id'])){
			die(json_encode(array('status' => '-3')));
		}
		
		echo json_encode($commercialist[0]);
	}
	else if($postData['action'] == 'postCustomer'){
		
		if(!isset($postData['data'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if($postData['data']['type'] == 'insert'){
			
			if(!$customer = queryDb($dc, "INSERT INTO customers SET name = '".$postData['data']['name']."', phone_number = '".$postData['data']['number']."', location = '".$postData['data']['location']."', address = '".$postData['data']['address']."', description = '".$postData['data']['description']."', contact_person = '".$postData['data']['contact_person']."'", 1)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
			
		}
		else if($postData['data']['type'] == 'update'){
			
			if(!$customer = queryDb($dc, "UPDATE customers SET name = '".$postData['data']['name']."', phone_number = '".$postData['data']['number']."', location = '".$postData['data']['location']."', address = '".$postData['data']['address']."', description = '".$postData['data']['description']."', contact_person = '".$postData['data']['contact_person']."' WHERE id = ".$postData['data']['id'], 2)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
			
		}
		
		echo json_encode(array('status' => '1', 'id' => $customer));
	}
	else if($postData['action'] == 'postArticle'){
		
		if(!isset($postData['data'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if($postData['data']['type'] == 'insert'){
			if(!$article = queryDb($dc, "INSERT INTO articles SET name = '".$postData['data']['name']."', price = '".$postData['data']['price']."'", 1)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
		}
		else if($postData['data']['type'] == 'update'){
			if(!$article = queryDb($dc, "UPDATE articles SET name = '".$postData['data']['name']."', price = '".$postData['data']['price']."' WHERE id = ".$postData['data']['id'], 2)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
		}
		else if($postData['data']['type'] == 'remove'){
			if(!$article = queryDb($dc, "DELETE FROM articles WHERE id = ".$postData['data']['id'], 2)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
		}
		
		echo json_encode(array('status' => '1', 'id' => $article));
	}
	else if($postData['action'] == 'postCommercialist'){
		
		if(!isset($postData['data'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if($postData['data']['type'] == 'insert'){
			if(!$commercialist = queryDb($dc, "INSERT INTO commercialists SET name = '".$postData['data']['name']."'", 1)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
		}
		else if($postData['data']['type'] == 'remove'){
			if(!$commercialist = queryDb($dc, "DELETE FROM commercialists WHERE id = ".$postData['data']['id'], 2)){
				die(json_encode(array('status' => '-3', 'error' => $dc->error)));
			}
		}
		
		echo json_encode(array('status' => '1', 'id' => $commercialist));
	}	
	else if($postData['action'] == 'postOrder'){
		
		if(!isset($postData['data'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if($postData['data']['type'] == 'insert'){
			
			$data = array();
			$order = $postData['data']['order'];
			
			if(!$customer = queryDb($dc, "SELECT * from customers where id = ".$order['customer']['id'])){
				die(json_encode(array('status' => '-4', 'error' => $dc->error)));
			}
			
			$data['customer']['name'] = $customer[0]['name'];
			$data['customer']['contact_person'] = $customer[0]['contact_person'];
			$data['customer']['phone_number'] = $customer[0]['phone_number'];
			$data['customer']['location'] = $customer[0]['location'];
			$data['customer']['description'] = $customer[0]['description'];
			$data['commercialist'] = $order['commercialist']['name'];
			$data['articles'] = array();
			$data['sub_total'] = 0;
			$data['note'] = preg_replace( '/\s\s+/', ' ', $order['note']);
			$data['paymentMethod'] = $order['paymentMethod'] == 1 ? "Diskontno" : "Žiralno";
			
			foreach($order['articles'] as $_article){
				array_push($data['articles'], array('name' => $_article['name'],'price' => $_article['price'],'quantity' =>  $_article['quantity']));
				$data['sub_total'] = $data['sub_total'] + (((float)$_article['quantity']) * ((float)$_article['price']));
			}
			
			if(!$order_count = queryDb($dc, "select count(*)+1 as C from orders where cid = ".$order['commercialist']['id']." and str_to_date(date, '%d/%m/%Y') >= str_to_date('01/01/".date("Y")."', '%d/%m/%Y')")) {
				die(json_encode(array('status' => '-6', 'error' => $dc->error)));
			}
			
			if(!$_order = queryDb($dc, "INSERT INTO orders SET order_number = ".$order_count[0]['C']." ,customer_id = ".$order['customer_id'].", cid = ".$order['commercialist']['id'].", json ='".json_encode($data, JSON_UNESCAPED_UNICODE)."', date = '".date("d/m/Y")."'", 1)){
				die(json_encode(array('status' => '-6', 'error' => $dc->error)));
			}
			
			$data['id'] = $order_count[0]['C'];
			
			$REPORT_NAME = $REPORT_NAMES[$postData['db']];
			
			if ($order['commercialist']['name'] != 'TEST') {
				require_once('./order/order.php');
			}
		}
		else if($postData['data']['type'] == 'remove'){
			if(!$_order = queryDb($dc, "DELETE FROM orders WHERE id = ".$postData['data']['id'], 2)){
				die(json_encode(array('status' => '-7', 'error' => $dc->error)));
			}
		}
		else if($postData['data']['type'] == 'update'){
			$data = array();
			$order = $postData['data']['order'];
			
			if(!$customer = queryDb($dc, "SELECT * from customers where id = ".$order['customer']['id'])){
				die(json_encode(array('status' => '-4', 'error' => $dc->error)));
			}
			
			if(!$old_order = queryDb($dc, "SELECT * from orders where id = ".$postData['data']['orderID'])){
				die(json_encode(array('status' => '-5', 'error' => $dc->error)));
			}
			
			$data['customer']['name'] = $customer[0]['name'];
			$data['customer']['contact_person'] = $customer[0]['contact_person'];
			$data['customer']['phone_number'] = $customer[0]['phone_number'];
			$data['customer']['location'] = $customer[0]['location'];
			$data['customer']['description'] = $customer[0]['description'];
			$data['commercialist'] = $order['commercialist']['name'];
			$data['articles'] = array();
			$data['sub_total'] = 0;
			$data['note'] = $order['note'];
			$data['paymentMethod'] = $order['paymentMethod'] == 1 ? "Diskontno" : "Žiralno";
			
			foreach($order['articles'] as $_article){
				array_push($data['articles'], array('name' => $_article['name'],'price' => $_article['price'],'quantity' =>  $_article['quantity']));
				$data['sub_total'] = $data['sub_total'] + (((float)$_article['quantity']) * ((float)$_article['price']));
			}
			
			if($old_order[0]['cid'] != $order['commercialist']['id']) {
				if(!$order_number = queryDb($dc, "SELECT order_number FROM `orders` WHERE `cid` = {$order['commercialist']['id']} order by `id` DESC LIMIT 1")) {
					$order_number = array(array('order_number' => 0));
				}
			}
			
			$query = "UPDATE orders SET".(isset($order_number[0]['order_number']) ? ' order_number = '.(intval($order_number[0]['order_number']) + 1).',' : '')." cid = {$order['commercialist']['id']}, customer_id = {$order['customer']['id']}, json ='".json_encode($data, JSON_UNESCAPED_UNICODE)."' where id = ".$postData['data']['orderID'];
			
			if(!$_order = queryDb($dc, $query, 2)){
				die(json_encode(array('status' => '-6', 'error' => $dc->error)));
			}
			
			if(!isset($order_count)) {
				if(!$order_number = queryDb($dc, "select order_number from orders where id = ".$postData['data']['orderID'])) {
					die(json_encode(array('status' => '-6', 'error' => $dc->error)));
				}
			}
			
			$data['id'] = $order_number[0]['order_number'];
			
			$data['update'] = true;
			
			$REPORT_NAME = $REPORT_NAMES[$postData['db']];
			
			if ($order['commercialist']['name'] != 'TEST') {
				require_once('./order/order.php');
			}
		}
		
		echo json_encode(array('status' => '1', 'id' => $_order));
	}
	else if($postData['action'] == 'getOrders'){
		
		if(!isset($postData['id']) || !isset($postData['type'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		$orders = array();
		
		if($postData['type'] == 0) {
			if(!$orders = queryDb($dc, 'select id,order_number,date, "" as name from orders where cid = '.$postData['id'].' order by id desc')){
				die(json_encode(array('status' => '-3')));
			}
		}
		else {
			if(!$orders = queryDb($dc, 'select id,order_number,date, (select commercialists.name from commercialists where commercialists.id = orders.cid) as name from orders where customer_id = '.$postData['id'].' order by id desc')){
				die(json_encode(array('status' => '-3')));
			}
		}
		
		echo json_encode(array('status' => '1', 'data' => $orders));
	}
	else if($postData['action'] == 'getOrdersByDate'){
		
		if(!isset($postData['id']) || !isset($postData['from']) || !isset($postData['to'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$orders = queryDb($dc, "select json from orders where cid = ".$postData['id']." and STR_TO_DATE(date, '%d/%m/%Y') >= STR_TO_DATE('".$postData['from']."', '%d/%m/%Y') and STR_TO_DATE(date, '%d/%m/%Y') <= STR_TO_DATE('".$postData['to']."', '%d/%m/%Y')")){
			die(json_encode(array('status' => '-3')));
		}
		$data = array();
		foreach($orders as $order){
			$order = json_decode($order['json'], true);
			foreach($order['articles'] as $article){
				if(!array_key_exists($article['name'], $data)){
					$data[$article['name']] = array(
						'name' => $article['name'],
						'price' => $article['price'],
						'quantity' => (int)$article['quantity']
					);
				}
				
				$data[$article['name']]['quantity'] += (int)$article['quantity'];
			}
		}
		
		$data = array_values($data);
		
		echo json_encode(array('status' => '1', 'data' => $data));
	}
	else if($postData['action'] == 'getOrder'){
		
		if(!isset($postData['id'])) die(json_encode(array('status' => '-3')));
		
		$dc = openConection($DB_INDEX[$postData['db']]);
		
		if(!$res = queryDb($dc, 'select customer_id,cid,json from orders where id = '.$postData['id'])){
			die(json_encode(array('status' => '-3')));
		}
		
		$order = json_decode($res[0]['json'], true);
		
		$data = array(
			'customer' => array(
				'name' => $order['customer']['name'],
				'id' => $res[0]['customer_id']
			),
			'articles' => $order['articles'],
			'commercialist' => array(
				'name' => $order['commercialist'],
				'id' => $res[0]['cid']
			),
			'note' => $order['note'],
			'paymentMethod' => $order['paymentMethod'] == "Diskontno" ? 1 : 2
			
		);
		
		echo json_encode(array('status' => '1', 'data' => $data));
	}
	else if($postData['action'] == 'getVersion'){
		echo '{"version": "'.VERSION.'"}';
	}
	else if($postData['action'] == 'sendEmail') {
		require_once('./order/view_from_to_email.php');
		
		echo json_encode(array('status' => '1'));
	}
	
	function queryDb($db_conn, $sql, $insert = 0){
		if(!$result = $db_conn->query($sql)){
			error_log( $db_conn->error);
			return 0;
		}
		if($insert == 0) {
			$out = array();

			while($row = $result->fetch_assoc()){
				array_push($out, $row);
			}
			
			return $out;
		}else if($insert == 1) {
			return $db_conn->insert_id;
		}
		return 1;
	}
	
?>