<?php
require __DIR__ . '/vendor/autoload.php';

ob_start();

include('order_template.php');

$html = ob_get_contents();

ob_end_clean();

$mpdf = new \Mpdf\Mpdf([
        'mode' => 'utf-8', 
        'format' => 'A4', 
        'orientation' => 'P'
]);

$mpdf->WriteHTML(mb_convert_encoding($html, 'UTF-8', 'UTF-8'));
$content = $mpdf->Output('', 'S');

$attachment = new Swift_Attachment($content, 'narudzba.pdf', 'application/pdf');

$message = Swift_Message::newInstance()
  ->setSubject('Narudzba '.$data['id'].' - '.$data['commercialist'].' - '.date("d/m/Y").(isset($data['update']) ? ' - IZMJENA ' : ''))
  ->setFrom(array('info@mixy.ba'))
  ->setTo(array('horeca@mixy.ba'))
  ->setBody('')
  ->attach($attachment);

$transport = Swift_MailTransport::newInstance();

$mailer = Swift_Mailer::newInstance($transport);

$mailer->send($message);
