<?php
	if (isset($_SERVER['HTTP_ORIGIN'])) {
		header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
		header('Access-Control-Allow-Credentials: true');
		header('Access-Control-Max-Age: 86400');
		header('Access-Control-Allow-Headers: Range');
		header('Access-Control-Expose-Headers: Accept-Ranges, Content-Encoding, Content-Length, Content-Range');
	}if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

	if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

	if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
		header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
		exit(0); 
	}
	
	date_default_timezone_set('Europe/Sarajevo');
	
if(!isset($_GET['id']) || !isset($_GET['from']) || !isset($_GET['to']) || !isset($_GET['type']) || !isset($_GET['db'])) die(json_encode(array('status' => '-3')));

require __DIR__ . '/vendor/autoload.php';

$DB_INDEX = array(
	'DB_DATABASE1',
	'DB_DATABASE2'
);
	
$REPORT_NAMES = array('HoReCa', 'Sličice');

$REPORT_NAME = $REPORT_NAMES[$_GET['db']];

require_once '../db.php';

$db_conn = openConection($DB_INDEX[$_GET['db']]);

$from = date_format(date_create($_GET['from']), 'd/m/Y');
$to = date_format(date_create($_GET['to']), 'd/m/Y');

if(!$result = $db_conn->query("select json from orders where ".( $_GET['type'] == '1' ? " cid = ".$_GET['id']." and" : ($_GET['type'] == '2' ? "" : " customer_id = ".$_GET['id']." and"))." STR_TO_DATE(date, '%d/%m/%Y') >= STR_TO_DATE('".$from."', '%d/%m/%Y') and STR_TO_DATE(date, '%d/%m/%Y') <= STR_TO_DATE('".$to."', '%d/%m/%Y')")){
	error_log( $db_conn->error);
	die();
}

$data = array();
$data2 = array();
$orders = array();

while($order = $result->fetch_assoc()){
	$order = json_decode($order['json'], true);
	array_push($orders, $order);
}

foreach($orders as $order) {
	foreach($order['articles'] as $article){
		$key = $article['name'];
		if(!array_key_exists($key, $data)){
			$data[$key] = array(
				'name' => $article['name'],
				'price' => 0,
				'quantity' => 0
			);
		}
		
		$data[$key]['quantity'] += (float)$article['quantity'];
		$data[$key]['price'] += (float)$article['price']*(float)$article['quantity'];
	}
}

$articles = array_values($data);
$paySum = array(
	'pm1' => 0,
	'pm2' => 0
);
foreach($orders as $order){
	
	$key2 = $order['paymentMethod'] == 'Diskontno' ? 'pm1' : 'pm2';
	
	foreach($order['articles'] as $article){
		$key = $article['name'].'-'.$article['price'];
		if(!array_key_exists($key, $data2)){
			$data2[$key] = array(
				'name' => $article['name'],
				'price' => (float)$article['price'],
				'pm1' => array(
					'price' => 0,
					'quantity' => 0
				),
				'pm2' => array(
					'price' => 0,
					'quantity' => 0
				)
			);
		}
		$data2[$key][$key2]['quantity'] += (float)$article['quantity'];
		$data2[$key][$key2]['price'] += (float)$article['price']*(float)$article['quantity'];
		$paySum[$key2] += (float)$article['price']*(float)$article['quantity'];
	}	
}

$articles2 = array_values($data2);
$data = array();

$data['articles'] = $articles;
$data['articles2'] = $articles2;
$data['paySum'] = $paySum;
$data['sub_total'] = 0;

foreach($articles as $article){
	$data['sub_total'] += (float)$article['price'];
}

ob_start();

include('order_template_2.php');

$html = ob_get_contents();

ob_end_clean();
$mpdf = new \Mpdf\Mpdf([
        'mode' => 'utf-8', 
        'format' => 'A4', 
        'orientation' => 'P'
]);

$mpdf->WriteHTML(mb_convert_encoding($html, 'UTF-8', 'UTF-8'));

$mpdf->Output('narudzba-'.$postData['oid'].'.pdf' ,'I');
